import 'package:flutter/widgets.dart';
import 'package:rxdart/rxdart.dart';

// ignore: prefer_mixin
class LifeCycleObserver with WidgetsBindingObserver {
  LifeCycleObserver({
    AppLifecycleState initialState = AppLifecycleState.resumed,
  }) {
    _subject = BehaviorSubject<AppLifecycleState>.seeded(
      initialState,
      onListen: () {
        _binding.addObserver(this);
      },
      onCancel: () {
        _binding.removeObserver(this);
      },
    );
  }

  final _binding = WidgetsBinding.instance;
  BehaviorSubject<AppLifecycleState> _subject;

  ValueObservable<AppLifecycleState> get stateValue => _subject.stream;
  Stream<AppLifecycleState> get stateStream => stateValue.skip(1);

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    _subject.sink.add(state);
  }

  void dispose() {
    _subject.close();
  }
}
